SystemOrganization addCategory: #MonticelloXml!
SystemOrganization addCategory: #'MonticelloXml-Test'!

MCMczReader subclass: #MCXmlReader
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlReader class methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:05'!
extension
	^'xml'! !

!MCXmlReader methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:25'!
loadDefinitions
	definitions := version snapshot definitions.
! !

!MCXmlReader methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:06'!
loadDependencies
	dependencies := version dependencies! !

!MCXmlReader methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:06'!
loadPackage
	package := version package.! !

!MCXmlReader methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:07'!
loadVersionInfo
	info := version info.! !

!MCXmlReader methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:25'!
stream: aStream
	stream := (SixxReadStream on: aStream).
	version := stream contents first.! !

MCWriter subclass: #MCXmlWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlWriter class methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 12:50'!
fileOut: aVersion on: aStream
	| inst |
	inst := self on: (SixxWriteStream on: aStream).
	inst writeVersion: aVersion.
	inst close.
! !

!MCXmlWriter class methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 12:30'!
readerClass
	^MCXmlReader! !

!MCXmlWriter methodsFor: 'closing' stamp: 'rt 11/14/2007 12:26'!
close
	stream close! !

!MCXmlWriter methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 13:42'!
writeVersion: aVersion
	stream nextPut: aVersion.! !

MCVersion subclass: #MCXmlVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlVersion methodsFor: 'as yet unclassified' stamp: 'rt 11/15/2007 20:29'!
writerClass
	^ MCXmlWriter ! !

MCWorkingCopyBrowser subclass: #MCXmlWorkingCopyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!MCXmlWorkingCopyBrowser methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 01:11'!
askTheUserForTheFormat
	^TCToolForXmlFormatRequest new showModally! !

!MCXmlWorkingCopyBrowser methodsFor: 'as yet unclassified' stamp: 'cop 11/17/2007 14:34'!
saveVersion
	| repo answer |
	answer := self useXmlFormat.
	answer ifNil: [^nil].
	answer = #xml ifFalse: [^super saveVersion].
	
	self canSave ifFalse: [^self].
	self checkForNewerVersions ifFalse: [^self].
	repo _ self repository.
	workingCopy newVersion ifNotNilDo:
		[:aVersion |	
		(MCVersionInspector new version: aVersion) show.
		Cursor wait showWhile: [repo storeVersion: aVersion].
		MCCacheRepository default cacheAllFileNamesDuring: 
			[repo cacheAllFileNamesDuring: 
				[aVersion allAvailableDependenciesDo:
					[:dep |
					(repo includesVersionNamed: dep info name)
						ifFalse: [repo storeVersion: dep]]]]]! !

!MCXmlWorkingCopyBrowser methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 01:11'!
useXmlFormat
	^self askTheUserForTheFormat! !

MCTool subclass: #TCToolForXmlFormatRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml'!

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 00:39'!
buttonSpecs
	^ #((Xml chooseXml 'choose xml for the package')
		(Mcz chooseMcz 'choose mcz for the package')
		(Cancel cancel 'cancel saving version')
		) ! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 00:41'!
cancel
	self answer: nil! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 00:41'!
chooseMcz
	self answer: #mcz! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 00:41'!
chooseXml
	self answer: #xml! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 01:16'!
defaultExtent 
	^ 300@100! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 00:49'!
defaultLabel
	^'Format Request'! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 00:58'!
question
	^'Please choose a format for the package.'! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 01:17'!
showModally
	modal := true.
	self window openInWorldExtent: self defaultExtent.
	[self window world notNil] whileTrue: [
		self window outermostWorldMorph doOneCycle.
	].
	morph := nil.
	^ modalValue! !

!TCToolForXmlFormatRequest methodsFor: 'as yet unclassified' stamp: 'rt 11/16/2007 01:15'!
widgetSpecs
	^ #(	
		((textMorph: question) (0 0 1 0) (0 0 0 30))
		((buttonRow) (0 1 1 1) (0 -30 0 0))
		)! !

TestCase subclass: #MCXmlTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloXml-Test'!

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 16:27'!
assertVersion: version isEqualVersion: version2 

	self assert: version package = version2 package.
	self assert: version info = version2 info.
	self assert: version snapshot = version2 snapshot.
	self assert: version dependencies = version2 dependencies.! !

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 16:39'!
createVersion
	^ MCVersion 
		package: (MCPackage named: 'testPack')
		info: self createVersionInfo
		snapshot: MCSnapshot empty
		dependencies: { }! !

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 16:45'!
createVersionInfo
	^ MCVersionInfo name: 'Test-rt0.1' id: 'testID20071114' message: 'first-test-version' date: '14 November 2007' time: '16:45:00' author: 'authorRt' ancestors: '#()'! !

!MCXmlTest methodsFor: 'as yet unclassified' stamp: 'rt 11/14/2007 17:13'!
testContent
	| stream version xmlReader |
	version := self createVersion.
	stream := RWBinaryOrTextStream on: ''.
	MCXmlWriter fileOut: version on: stream.
	stream reset.
	xmlReader := MCXmlReader on: stream.
	stream close.
	self assertVersion: version isEqualVersion: xmlReader version! !
